// =====================================================================
//  $Id: TOutputObjectSocket.cc,v 1.5 2004/03/07 10:30:32 goiwai Exp $
//  $Name: CLDAQ-1-14-06 $
//  $Log: TOutputObjectSocket.cc,v $
//  Revision 1.5  2004/03/07 10:30:32  goiwai
//  ROOTに組みこむためのおまじないマクロを埋めこみました。
//  全てにおいて完全に動作するわけではありません。
//
//  Revision 1.4  2003/12/06 10:56:19  goiwai
//  フィルタ関連の修整と Read(),Write()の戻り値の修整です.
//  Read()もWrite()も処理したレコードサイズを返します.
//  フィルタがある場合も同様です.
//  それぞれのストリームのDataSizeの扱いですが,これは扱ったレコードサイズ
//  でなく扱ったファイルやソケットなどのサイズになります.レコードサイズと
//  一致するとは限りません.
//
//  Revision 1.3  2003/10/06 17:02:42  goiwai
//  *** empty log message ***
//
//  Revision 1.2  2003/07/30 16:19:31  goiwai
//  ファイルにコミットログをつけることにしました.
//
// =====================================================================
#include "TOutputObjectSocket.hh"
#include "TStreamableObject.hh"
#include "TOutputObjectFilter.hh"

TOutputObjectSocket::TOutputObjectSocket( const Tstring& hostname, Tint port )
  : TObjectSocket( port ), TOutputObjectStream( tSocketStream ), 
    theServerName( hostname ), theHostInformation( 0 )
{
  initialize();
}

TOutputObjectSocket::TOutputObjectSocket( Tint port )
  : TObjectSocket( port ), TOutputObjectStream( tSocketStream ), 
    theServerName( "localhost" ), theHostInformation( 0 )
{
  initialize();
}

TOutputObjectSocket::TOutputObjectSocket( TOutputObjectFilter* filter, const Tstring& hostname, Tint port )
  : TObjectSocket( port ), TOutputObjectStream( filter, tSocketStream ), 
    theServerName( hostname ), theHostInformation( 0 )
{
  initialize();
}

TOutputObjectSocket::TOutputObjectSocket( TOutputObjectFilter* filter, Tint port )
  : TObjectSocket( port ), TOutputObjectStream( filter, tSocketStream ), 
    theServerName( "localhost" ), theHostInformation( 0 )
{
  initialize();
}

TOutputObjectSocket::~TOutputObjectSocket()
{
  CloseServer();
}

Tvoid TOutputObjectSocket::initialize()
{
  theHostInformation = gethostbyname( theServerName.c_str() );
  if ( theHostInformation == 0 ) {
    perror( "TOutputObjectSocket::initialize" );
    exit( -errno );
  }
  theAddress.sin_family = PF_INET;
  theAddress.sin_port = htons( (TUshort)thePortNumber );
  theAddress.sin_addr.s_addr =
    *( (unsigned long *)( *( theHostInformation -> h_addr_list ) ) );

  OpenServer();
  Tsocklen_t len = (Tsocklen_t)( Tsizeof( theAddress ) );

  if ( connect( theServerDescriptor, (struct sockaddr *)&theAddress, len ) == -1 )
    perror( "TOutputObjectSocket::initialize" );


  return;
}

Tint TOutputObjectSocket::Write( TStreamableObject& object )
{
  if ( HasFilter() ) {
    return theObjectFilter -> Filtering( object, this );
  }

  theLastDataSize = theDataSize;
  theDataSize = 0;
  theDataSize = object.Record( this );
  theTotalDataSize += theDataSize;

  return theDataSize;
}

#ifdef __CLDAQ_ROOT_DLL
    ClassImp(TOutputObjectSocket)
#endif
